package ajedrez.server.dominio;

import java.lang.reflect.Field;
import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.Hashtable;
import java.util.Vector;

import ajedrez.client.comunicaciones.IJugador;
import ajedrez.client.presen.IVentanaTablero;
import ajedrez.server.comunicaciones.AjedrezServer;
import ajedrez.server.persistencia.Metodos;
import ajedrez.server.presen.FVentanaServidor;
import junit.framework.TestCase;


import mockit.Mock;
import mockit.Mockit;


public class TestASJMokitTablero extends TestCase{


	public static class MyRandom{

		@Mock
		public static double random(){
			return 0.12345;
		}
	}
	private class StubJugador implements IJugador{

		String name;


		public StubJugador(String n){
			this.name = n;
		}

		@Override
		public void MostrarInfoAbandono() throws RemoteException {
			// TODO Auto-generated method stub

		}


		Vector se = new Vector();
		public void RellenerSalaEspera(Vector arg0) throws RemoteException {
			// TODO Auto-generated method stub
			se.addAll(arg0);
		}


		int a1;
		String a2;
		String a3;
		public void actualizar(int arg0, String arg1, String arg2)
		throws RemoteException {
			// TODO Auto-generated method stub
			a1=arg0;
			a2=arg1;
			a3=arg2;
		}

		@Override
		public void borrarJugSalaEspera(String arg0) throws RemoteException {
			// TODO Auto-generated method stub
			se.remove(arg0);
		}

		@Override
		public void cierreForzoso() throws RemoteException {
			// TODO Auto-generated method stub

		}

		int ctR;
		char ctRC;
		@Override
		public void contestarReto(int arg0, char arg1) throws RemoteException {
			// TODO Auto-generated method stub
			ctR=arg0;
			ctRC=arg1;
		}

		boolean ctt;
		@Override
		public void contestarTablas(boolean arg0) throws RemoteException {
			// TODO Auto-generated method stub
			ctt=arg0;
		}

		@Override
		public String getNombre() throws RemoteException {
			// TODO Auto-generated method stub
			return this.name;
		}

		String nJ;
		@Override
		public void mostrarJugadorNuevo(String arg0) throws RemoteException {
			// TODO Auto-generated method stub
			nJ=arg0;
		}

		@Override
		public void proponerTablas() throws RemoteException {
			// TODO Auto-generated method stub

		}

		String retar;
		@Override
		public void retar(String arg0) throws RemoteException {
			// TODO Auto-generated method stub
			retar = arg0;
		}

		int rc1;
		int rc2;
		char rcC;
		@Override
		public void rivalCorono(int arg0, int arg1, char arg2)
		throws RemoteException {
			// TODO Auto-generated method stub
			rc1 = arg0;
			rc2 = arg1;
			rcC = arg2;
		}

		IVentanaTablero t;
		@Override
		public void setTablero(IVentanaTablero arg0) throws RemoteException {
			// TODO Auto-generated method stub
			t = arg0;
		}

	}

	private AjedrezServer as;
	private FVentanaServidor vs;


	String user1 = "test1";
	String user2 = "test2";
	String pass1 = "pass1";
	String pass2 = "pass2";

	StubJugador j1 = new StubJugador(user1);
	StubJugador j2 = new StubJugador(user2);
	StubJugador j3 = new StubJugador("j3");
	StubJugador j4 = new StubJugador("j4");


	Tablero t;

	protected Peon addPeon(int fila, int colum, char color, int numero){
		Peon p = new Peon(1, color, fila-1, colum-1);
		Pieza[][] tablero = t.getTablero();
		tablero[fila-1][colum-1] = p;
		
		if(color == 'b'){
			t.getBlancas()[numero] = p;
			
		}else{
			t.getNegras()[numero] = p;
		}
		return p;
	}
	
	protected Torre addTorre1(int fila, int colum, char color){
		Torre p = new Torre(1, color, fila-1, colum-1);
		Pieza[][] tablero = t.getTablero();
		tablero[fila-1][colum-1] = p;
		if(color == 'b'){
			t.getBlancas()[t.fnTorre1] = p;
		}else{
			t.getNegras()[t.fnTorre1] = p;
		}
		return p;
	}
	protected Torre addTorre2(int fila, int colum, char color){
		Torre p = new Torre(1, color, fila-1, colum-1);
		Pieza[][] tablero = t.getTablero();
		tablero[fila-1][colum-1] = p;
		if(color == 'b'){
			t.getBlancas()[t.fnTorre2] = p;
		}else{
			t.getNegras()[t.fnTorre2] = p;
		}
		return p;
	}
	
	protected Caballo addCaballo1(int fila, int colum, char color){
		Caballo p = new Caballo(1, color, fila-1, colum-1);
		Pieza[][] tablero = t.getTablero();
		tablero[fila-1][colum-1] = p;
		if(color == 'b'){
			t.getBlancas()[t.fnCaballo1] = p;
		}else{
			t.getNegras()[t.fnCaballo1] = p;
		}
		return p;
	}
	protected Caballo addCaballo2(int fila, int colum, char color){
		Caballo p = new Caballo(1, color, fila-1, colum-1);
		Pieza[][] tablero = t.getTablero();
		tablero[fila-1][colum-1] = p;
		if(color == 'b'){
			t.getBlancas()[t.fnCaballo2] = p;
		}else{
			t.getNegras()[t.fnCaballo2] = p;
		}
		return p;
	}
	
	protected Alfil addAlfil1(int fila, int colum, char color){
		Alfil p = new Alfil(1, color, fila-1, colum-1);
		Pieza[][] tablero = t.getTablero();
		tablero[fila-1][colum-1] = p;
		if(color == 'b'){
			t.getBlancas()[t.fnAlfil1] = p;
		}else{
			t.getNegras()[t.fnAlfil1] = p;
		}
		return p;
	}
	protected Alfil addAlfil2(int fila, int colum, char color){
		Alfil p = new Alfil(1, color, fila-1, colum-1);
		Pieza[][] tablero = t.getTablero();
		tablero[fila-1][colum-1] = p;
		if(color == 'b'){
			t.getBlancas()[t.fnAlfil2] = p;
		}else{
			t.getNegras()[t.fnAlfil2] = p;
		}
		return p;
	}
	
	protected Dama addDama(int fila, int colum, char color){
		Dama p = new Dama(1, color, fila-1, colum-1);
		Pieza[][] tablero = t.getTablero();
		tablero[fila-1][colum-1] = p;
		if(color == 'b'){
			t.getBlancas()[t.fnDama] = p;
		}else{
			t.getNegras()[t.fnDama] = p;
		}
		return p;
	}
	
	protected Rey addRey(int fila, int colum, char color){
		Rey p = new Rey(1, color, fila-1, colum-1);
		Pieza[][] tablero = t.getTablero();
		tablero[fila-1][colum-1] = p;
		if(color == 'b'){
			t.getBlancas()[t.fnRey] = p;
		}else{
			t.getNegras()[t.fnRey] = p;
		}
		return p;
	}
	
	protected void setUp(){

		Mockit.setUpMock(Math.class,MyRandom.class);

		partidaInserted = new Vector<String>();
		try {
			as = new AjedrezServer();
			vs = new FVentanaServidor(as);
			as.identificar(user1, j1);
			as.identificar(user2, j2);
			as.identificar("j3", j3);
			as.identificar("j4", j4);
			as.contestarReto(this.user1, this.user2, true);
			
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SecurityException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 

	}
	
	private void vaciarTablero(){
		Field f;
		try {
			f = AjedrezServer.class.getDeclaredField("htPartidasAjedrez");
			f.setAccessible(true);
			Hashtable<Integer, Tablero> ht = (Hashtable<Integer, Tablero>) f.get(as);
			t = ht.get(j1.ctR);
			
			Pieza[][] tablero = t.getTablero();
			for(int i = 0;i<tablero.length;i++){
				for(int j = 0;j<tablero[i].length;j++){
					tablero[i][j] = null;
				}
			}
			
			Pieza[] pb = t.getBlancas();
			for(int i = 0;i<pb.length;i++){
				pb[i] = null;
			}
			
			
			Pieza[] pn = t.getNegras();
			for(int i = 0;i<pn.length;i++){
				pn[i] = null;
			}
		} catch (SecurityException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NoSuchFieldException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	Vector<String> partidaInserted;
	
	protected void tearDown(){

		Mockit.tearDownMocks(Math.class);

		PreparedStatement p = null;
		Connection bd = null;

		if(this.partidaInserted.size()>0){
			for(String part : partidaInserted){
				String SQL1 = "Delete from [Historial Partidas]  where [Id Partida] = ?;";
				try {
					String [] info = Metodos.getInfo();
					bd = DriverManager.getConnection("jdbc:sqlserver://" + info[0] + ":" + info[1] + ";DatabaseName=" + info[2], info[3], info[4]);
					p = bd.prepareStatement(SQL1);
					p.setString(1, part);
					p.executeUpdate();
				}
				catch (SQLException eSQL) {
					eSQL.printStackTrace(); 
				}
				finally {
					try {
						bd.close();
					}
					catch (SQLException eSQL) {
						eSQL.printStackTrace();
					}
				}
			}

		}
	}

	
	public void testRetar(){
		StubJugador j3 = new StubJugador("j3");
		StubJugador j4 = new StubJugador("j4");
		try {
			as.identificar("j3", j3);
			as.identificar("j4", j4);

			as.contestarReto("j3", "j4", true);

			assertTrue(j3.ctR==j4.ctR);
			assertTrue(j3.ctRC=='n');
			assertTrue(j4.ctRC=='b');

		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}


	public void testMover(){
		try {

			int r = as.mover(j2.ctR, j2.ctRC, "a2", "a4");
			assertTrue(r == 0);

			r = as.mover(j1.ctR, j1.ctRC, "a7", "a5");
			assertTrue(r == 0);
		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}

	public void testJaqueMate(){
		try {
			this.partidaInserted.add(""+j1.ctR);

			int r = as.mover(j2.ctR, j2.ctRC, "e2", "e4");
			assertTrue(r == 0);
			r = as.mover(j1.ctR, j1.ctRC, "a7", "a6");
			assertTrue(r == 0);

			r = as.mover(j2.ctR, j2.ctRC, "d1", "f3");
			assertTrue(r == 0);
			r = as.mover(j1.ctR, j1.ctRC, "a6", "a5");
			assertTrue(r == 0);

			r = as.mover(j2.ctR, j2.ctRC, "f1", "c4");
			assertTrue(r == 0);
			r = as.mover(j1.ctR, j1.ctRC, "a5", "a4");
			assertTrue(r == 0);

			r = as.mover(j2.ctR, j2.ctRC, "f3", "f7");
			assertTrue(r+"",r/10 == 2);


		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
	
	public void testJaqueMate2(){
		try {
			this.partidaInserted.add(""+j1.ctR);

			int r = as.mover(j2.ctR, j2.ctRC, "h2", "h3");
			assertTrue(r == 0);
			
			r = as.mover(j1.ctR, j1.ctRC, "e7", "e5");
			assertTrue(r == 0);
			r = as.mover(j2.ctR, j2.ctRC, "a2", "a3");
			assertTrue(r == 0);

			r = as.mover(j1.ctR, j1.ctRC, "d8", "f6");
			assertTrue(r == 0);
			r = as.mover(j2.ctR, j2.ctRC, "a3", "a4");
			assertTrue(r == 0);

			r = as.mover(j1.ctR, j1.ctRC, "f8", "c5");
			assertTrue(r == 0);
			r = as.mover(j2.ctR, j2.ctRC, "a4", "a5");
			assertTrue(r == 0);

			r = as.mover(j1.ctR, j1.ctRC, "f6", "f2");
			assertTrue(r+"",r/10 == 2);


		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
	
	public void testJaqueTablas(){
		
		try {
			this.partidaInserted.add(""+j1.ctR);

			int r = as.mover(j2.ctR, j2.ctRC, "g1", "f3");
			assertTrue(r == 0);
			r = as.mover(j1.ctR, j1.ctRC, "g8", "f6");
			assertTrue(r == 0);
			
			r = as.mover(j2.ctR, j2.ctRC, "f3", "g1");
			assertTrue(r == 0);
			r = as.mover(j1.ctR, j1.ctRC, "f6", "g8");
			assertTrue(r == 0);
			
			
			
			 r = as.mover(j2.ctR, j2.ctRC, "g1", "f3");
			assertTrue(r == 0);
			r = as.mover(j1.ctR, j1.ctRC, "g8", "f6");
			assertTrue(r == 0);
			
			r = as.mover(j2.ctR, j2.ctRC, "f3", "g1");
			assertTrue(r == 0);
			r = as.mover(j1.ctR, j1.ctRC, "f6", "g8");
			assertTrue(r == 0);
			
			 r = as.mover(j2.ctR, j2.ctRC, "g1", "f3");
			assertTrue(r == 0);
			r = as.mover(j1.ctR, j1.ctRC, "g8", "f6");
			assertTrue(r == 0);
			
			r = as.mover(j2.ctR, j2.ctRC, "f3", "g1");
			assertTrue(r == 0);
			r = as.mover(j1.ctR, j1.ctRC, "f6", "g8");
			assertTrue(r+"",r == 30);
			
			


		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
	
	public void testJaque(){
		this.vaciarTablero();
		this.addRey(5, 5, 'n');
		this.addRey(8, 8, 'b');
		
		this.addDama(1, 2, 'b');
		
		try {

			int r = as.mover(j2.ctR, j2.ctRC, "g1", "d1");
			assertTrue(r/10 == 1);
			

		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
	
	public void testEnrocarLargo(){
		this.vaciarTablero();
		this.addRey(1, 4, 'b');
		this.addRey(8, 4, 'n');
		
		this.addTorre1(1, 8, 'b');
		
		try {

			int r = as.mover(j2.ctR, j2.ctRC, "e1", "c1");
			assertTrue(r+"",r == 6);
			

		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
	
	public void testEnrocarCorto(){
		this.vaciarTablero();
		this.addRey(1, 4, 'b');
		this.addRey(8, 4, 'n');
		
		this.addTorre1(1, 1, 'b');
		
		try {

			int r = as.mover(j2.ctR, j2.ctRC, "e1", "g1");
			assertTrue(r+"",r == 5);
			

		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
	
	public void testCombertirPeon(){
		this.vaciarTablero();
		this.addRey(1, 4, 'b');
		this.addRey(7, 4, 'n');
		
		this.addPeon(7, 1, 'b',1);
		
		try {
			
			int r = as.mover(j2.ctR, j2.ctRC, "h7", "h8");
			assertTrue(r+"",r == 2);
			r = as.convertirPeon(j1.ctR, 'b', 'd', 8, 8);
			assertTrue(r+"",r == 0);
			

		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
	
	public void testCombertirPeonHaque(){
		this.vaciarTablero();
		this.addRey(1, 4, 'b');
		this.addRey(8, 4, 'n');
		
		this.addPeon(7, 1, 'b',1);
		
		try {
			
			int r = as.mover(j2.ctR, j2.ctRC, "h7", "h8");
			assertTrue(r+"",r == 2);
			r = as.convertirPeon(j1.ctR, 'b', 'd', 8, 8);
			assertTrue(r+"",r == 1);
			

		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
	
	public void testCombertirPeonHaqueMate(){
		this.vaciarTablero();
		this.addRey(1, 4, 'b');
		this.addRey(8, 4, 'n');
		
		this.addPeon(7, 1, 'b',1);
		this.addTorre1(7, 8, 'b');
		
		try {
			this.partidaInserted.add(""+j1.ctR);
			
			int r = as.mover(j2.ctR, j2.ctRC, "h7", "h8");
			assertTrue(r+"",r == 2);
			r = as.convertirPeon(j1.ctR, 'b', 'd', 8, 8);
			assertTrue(r+"",r == 2);
			

		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
	
	public void testCombertirPeonTablas(){
		this.vaciarTablero();
		this.addRey(1, 4, 'b');
		this.addRey(7, 4, 'n');
		
		this.addPeon(7, 2, 'b',1);
		this.addTorre1(6, 8, 'b');
		this.addTorre2(1, 5, 'b');
		this.addDama(1, 3, 'b');
		
		try {
			this.partidaInserted.add(""+j1.ctR);
			
			int r = as.mover(j2.ctR, j2.ctRC, "g7", "g8");
			assertTrue(r+"",r == 2);
			r = as.convertirPeon(j1.ctR, 'b', 'd', 8, 8);
			assertTrue(r+"",r == 3);
			

		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
	
	
	public void testCombertirPeonNegras(){
		this.vaciarTablero();
		this.addRey(2, 4, 'b');
		this.addRey(7, 4, 'n');
		
		this.addPeon(2, 1, 'n',1);
		
		try {
			
			int r = as.mover(j2.ctR, j2.ctRC, "e2", "d2");
			assertTrue(r+"",r == 0);
			
			r = as.mover(j1.ctR, j1.ctRC, "h2", "h1");
			assertTrue(r+"",r == 2);
			r = as.convertirPeon(j1.ctR, 'n', 'd', 1, 8);
			assertTrue(r+"",r == 0);
			

		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}

	public void testProponerTablas(){
		try {
			this.partidaInserted.add(""+j1.ctR);
			
			as.proponerTablas(j1.ctR, j1.ctRC);
			as.contestarTablas(j2.ctR, j2.ctRC, true);
			assertTrue(j1.ctt);

		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
	
	public void testProponerTablasNo(){
		try {
			
			as.proponerTablas(j2.ctR, j2.ctRC);
			as.contestarTablas(j1.ctR, j1.ctRC, false);
			assertTrue(j2.ctt==false);

		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
	
	public void testAbandonar1(){
		try {
			this.partidaInserted.add(""+j1.ctR);
			as.abandonar(j1.ctR, j1.ctRC);

		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
	
	public void testAbandonar2(){
		try {
			this.partidaInserted.add(""+j2.ctR);
			as.abandonar(j2.ctR, j2.ctRC);

		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
	
	
	public void testMoverBB_CB(){
		try {

			int r = as.mover(j2.ctR, j2.ctRC, "b2", "b4");
			assertTrue(r == 0);

			r = as.mover(j1.ctR, j1.ctRC, "a7", "a5");
			assertTrue(r == 0);
			
			 r = as.mover(j2.ctR, j2.ctRC, "c1", "b2");
			assertTrue(r == 0);
		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
}
