package ajedrez.server.dominio;

import junit.framework.TestCase;

public class TestMoverTorre extends TestCase {

	
private Tablero t;
	
	protected void setUp(){
		t = new Tablero(1, "ja", "jb");
		Pieza[][] tablero = t.getTablero();
		for(int i = 0;i<tablero.length;i++){
			for(int j = 0;j<tablero[i].length;j++){
				tablero[i][j] = null;
			}
		}
	}
	
	
	protected Peon addPeon(int fila, int colum, char color){
		Peon p = new Peon(1, color, fila-1, colum-1);
		Pieza[][] tablero = t.getTablero();
		tablero[fila-1][colum-1] = p;
		return p;
	}
	
	protected Torre addTorre(int fila, int colum, char color){
		Torre p = new Torre(1, color, fila-1, colum-1);
		Pieza[][] tablero = t.getTablero();
		tablero[fila-1][colum-1] = p;
		return p;
	}
	
	protected Caballo addCaballo(int fila, int colum, char color){
		Caballo p = new Caballo(1, color, fila-1, colum-1);
		Pieza[][] tablero = t.getTablero();
		tablero[fila-1][colum-1] = p;
		return p;
	}
	
	protected Alfil addAlfil(int fila, int colum, char color){
		Alfil p = new Alfil(1, color, fila-1, colum-1);
		Pieza[][] tablero = t.getTablero();
		tablero[fila-1][colum-1] = p;
		return p;
	}
	
	protected Dama addDama(int fila, int colum, char color){
		Dama p = new Dama(1, color, fila-1, colum-1);
		Pieza[][] tablero = t.getTablero();
		tablero[fila-1][colum-1] = p;
		return p;
	}
	
	protected Rey addRey(int fila, int colum, char color){
		Rey p = new Rey(1, color, fila-1, colum-1);
		Pieza[][] tablero = t.getTablero();
		tablero[fila-1][colum-1] = p;
		return p;
	}
	
	
	
	public void testMoverID(){
		this.addTorre(5, 1, 'b');
		int d = t.mover('b', 5, 1, 5, 8,"h5", "a5");
		assertTrue(d == 0);
	}
	
	public void testMoverArAb(){
		this.addAlfil(1, 5, 'b');
		int d = t.mover('b', 1, 5, 8, 5,"d1", "d8");
		assertTrue(d == 0);
	}
	
	public void testMoverDI(){
		this.addAlfil(5, 8, 'b');
		int d = t.mover('b', 5, 8, 5, 1,"a5", "h5");
		assertTrue(d == 0);
	}
	
	public void testMoverAbAr(){
		this.addAlfil(8, 5, 'b');
		int d = t.mover('b', 8, 5, 1, 5,"d8", "d1");
		assertTrue(d == 0);
	}
	
	public void testMoverIDbloc(){
		this.addTorre(5, 1, 'b');
		this.addPeon(5, 4, 'b');
		int d = t.mover('b', 5, 1, 5, 8,"h5", "a5");
		assertTrue(d == -6);
	}
	
	public void testMoverArAbbloc(){
		this.addAlfil(1, 5, 'b');
		this.addPeon(5, 5, 'b');
		int d = t.mover('b', 1, 5, 8, 5,"d1", "d8");
		assertTrue(d == -6);
	}
	
	public void testMoverDIbloc(){
		this.addAlfil(5, 8, 'b');
		this.addPeon(5, 4, 'b');
		int d = t.mover('b', 5, 8, 5, 1,"a5", "h5");
		assertTrue(d == -6);
	}
	
	public void testMoverAbArbloc(){
		this.addAlfil(8, 5, 'b');
		this.addPeon(5, 5, 'b');
		int d = t.mover('b', 8, 5, 1, 5,"d8", "d1");
		assertTrue(d == -6);
	}
	
	
	
	
}
