package ajedrez.server.presen;

import org.uispec4j.PasswordField;
import org.uispec4j.TextBox;
import org.uispec4j.Trigger;
import org.uispec4j.UISpecTestCase;
import org.uispec4j.Window;
import org.uispec4j.interception.MainClassAdapter;
import org.uispec4j.interception.WindowHandler;
import org.uispec4j.interception.WindowInterceptor;


public class TestInterfaces extends UISpecTestCase {


	public static void main(String [] args){
		JFLanzadorServer jfl = new JFLanzadorServer();
		jfl.setVisible(true);
	}

	protected void setUp() throws Exception {
		setAdapter(new MainClassAdapter(TestInterfaces.class, new String[0]));
	}


	public void testCheckTBoxes(){
		Window w = getMainWindow();

		TextBox tb = w.getTextBox("sa");
		assertTrue(tb!=null);

		tb = w.getTextBox("161.67.106.84");
		assertTrue(tb!=null);

		tb = w.getTextBox("1433");
		assertTrue(tb!=null);

		tb = w.getTextBox("ajedrez6");
		assertTrue(tb!=null);

		tb = w.getTextBox("127.0.0.1");
		assertTrue(tb!=null);

		tb = w.getTextBox("2995");
		assertTrue(tb!=null);

		PasswordField pf = w.getPasswordField("pedro");
		assertTrue(pf!=null);

	}


	public void testConectarDesconectar(){

		Window main = getMainWindow();

		Window window = WindowInterceptor.run(main.getButton("Conectar").triggerClick());

		assertTrue(window.getTitle().equals("Servidor"));

		window.getButton("Desconectar").click();

	}

	public void testfalloRMIIP(){
		Window w = getMainWindow();

		TextBox tb = w.getTextBox("127.0.0.1");
		assertTrue(tb!=null);

		tb.setText("abc");

		WindowInterceptor.init(
			w.getButton("Conectar").triggerClick()).process(
					new WindowHandler() {
						public Trigger process(Window window) {
	         assertTrue(window.getTitle().contains("Error"));
	         assertTrue(window.getTitle().contains("RMI"));
							return window.getButton("Aceptar").triggerClick();
	        }
	      }
		).run();
	}

	public void testfalloRMIPort(){
		Window w = getMainWindow();

		TextBox tb = w.getTextBox("2995");
		assertTrue(tb!=null);

		tb.setText("abc");

		WindowInterceptor.init(
			w.getButton("Conectar").triggerClick()).process(
					new WindowHandler() {
						public Trigger process(Window window) {
	         assertTrue(window.getTitle().contains("Error"));
	         assertTrue(window.getTitle().contains("RMI"));
							return window.getButton("Aceptar").triggerClick();
	        }
	      }
		).run();
	}

	public void testfalloDBPuerto(){
		Window w = getMainWindow();

		TextBox tb = w.getTextBox("1433");
		assertTrue(tb!=null);

		tb.setText("abc");

		WindowInterceptor.init(
			w.getButton("Conectar").triggerClick()).process(
					new WindowHandler() {
						public Trigger process(Window window) {
	         assertTrue(window.getTitle().contains("Error"));
	         assertTrue(window.getTitle().contains("base de datos"));
							return window.getButton("Aceptar").triggerClick();
	        }
	      }
		).run();
	}

}
